
#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform sampler2D u_texture;

uniform vec2 blurSize;
uniform vec4 substract;

//const float blurSize = 1.0/512.0;

//uniform float offset[3] = float[](0.0, 1.3846153846, 3.2307692308);
//uniform float weight[3] = float[](0.2270270270, 0.3162162162, 0.0702702703);
float offset[3];
float weight[3];

//float a[5] = float[](3.4, 4.2, 5.0, 5.2, 1.1);

void main() {
    offset[0] = 0.0;
    offset[1] = 1.3846153846;
    offset[2] = 3.2307692308;
    weight[0] = 0.2270270270;
    weight[1] = 0.3162162162;
    weight[2] = 0.0702702703;
    
    vec4 sum = texture2D( u_texture, v_texCoord ) * weight[0];
    
    for (int j=1; j<5; j++) {
        for (int i=1; i<3; i++) {
            sum += texture2D( u_texture, v_texCoord+vec2(offset[i]*blurSize.x*float(j)/5.0, 0.0) ) * weight[i] / 4.0;// * 0.2;
        }
        
        for (int i=1; i<3; i++) {
            sum += texture2D( u_texture, v_texCoord+vec2(0.0, offset[i]*blurSize.y*float(j)/5.0) ) * weight[i] / 4.0;// * 0.2;
        }
    }
    
    gl_FragColor = sum * 1.0;
}

